%macro cycdrate ;

%global fmsetl_error;
%global fmsetl_errormsg;
%global fmsetl_statusId;
%global format_missing;

%let fmsetl_error = ;
%let fmsetl_errormsg = ;
%let fmsetl_statusId = 1 ; /* Will be changed to 0 if program runs successful */
%let format_missing = 0 ;

%let entry = cycdrate;
%let putlog = Y;

%let curr_rec_dttm = '01JAN5999:00:00'DT;

/******************************************************************************************/
/*                 This macro will write processing errors to the log                     */
/******************************************************************************************/

%macro _chkError ;
  %global _tmpRC;
  %let _tmpRC = 0;
  %if (&sysrc ne 0) or (&syserr ne 0 and &syserr ne 4) %then %do;
    %if (&sysrc ne 0) %then
        %let _tmpRC = &sysrc;
    %else
        %let _tmpRC = &syserr;
    %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=999
            , msgTxt1=&_tmpRC, msgTxt2=&sysmsg, msgPutlog=&putlog);
  %end;
%mend _chkError ;

data null ;
   call symput( 'nStartTime', datetime()) ;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

/******************************************************************************************/
/*                       Validation of global macro variables                             */
/******************************************************************************************/

%if %symexist(fmsetl_drateTypeIds_SDM) %then %do;
   %if %nrbquote(&fmsetl_drateTypeIds_SDM) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_drateTypeIds_SDM : &fmsetl_drateTypeIds_SDM>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_drateTypeIds_SDM>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_drateTypeCodes) %then %do;
   %if %nrbquote(&fmsetl_drateTypeCodes) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_drateTypeCodes : &fmsetl_drateTypeCodes>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_drateTypeCodes>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_dimensionTypeCodes) %then %do;
   %if %nrbquote(&fmsetl_dimensionTypeCodes) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_dimensionTypeCodes : &fmsetl_dimensionTypeCodes>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_dimensionTypeCodes>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_dimensionCodes) %then %do;
   %if %nrbquote(&fmsetl_dimensionCodes) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_dimensionCodes : &fmsetl_dimensionCodes>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_dimensionCodes>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_drateSetCode_DDS) %then %do;
   %if %nrbquote(&fmsetl_drateSetCode_DDS) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_drateSetCode_DDS : &fmsetl_drateSetCode_DDS>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_drateSetCode_DDS>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_processedDTTM_From) %then %do;
   %if %datatyp(&fmsetl_processedDTTM_From) ne NUMERIC %then %do;
      %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                msgTxt1=<fmsetl_processedDTTM_From : &fmsetl_processedDTTM_From>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_processedDTTM_From>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_processedDTTM_To) %then %do;
   %if %datatyp(&fmsetl_processedDTTM_To) ne NUMERIC %then %do;
      %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=1,
                msgTxt1=<fmsetl_processedDTTM_To : &fmsetl_processedDTTM_To>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_processedDTTM_To>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_tempCreateTableNm) %then %do;
   %if %nrbquote(&fmsetl_tempCreateTableNm) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_tempCreateTableNm : &fmsetl_tempCreateTableNm>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_tempCreateTableNm>, msgPutlog=&putlog);
   %goto exit;
%end;

%if %symexist(fmsetl_tempStatusTableNm) %then %do;
   %if %nrbquote(&fmsetl_tempStatusTableNm) = %str() %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=2,
               msgTxt1=<fmsetl_tempStatusTableNm : &fmsetl_tempStatusTableNm>, msgPutlog=&putlog);
      %goto exit;
   %end;
%end;
%else %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=15,
            msgTxt1=<fmsetl_tempStatusTableNm>, msgPutlog=&putlog);
   %goto exit;
%end;

/******************************************************************************************/
/*               Assign librefs for Conform(_CONFORM) and SASSDM(_SDMLIB)                 */
/******************************************************************************************/

%bldLibNm(sesetl_sasLibRef=_CONFORM
        , sesetl_OMRSASLibraryObjName=&Soldatatier_folder./&CONFLibObj./&CONFLibObj.
        , sesetl_useType=META
        , sesetl_validateLib=Y
        ) ;

%bldLibNm(sesetl_sasLibRef=_SDMLIB
        , sesetl_OMRSASLibraryObjName=&Solsystem_folder./&SdmLibObj./&SdmLibObj.
        , sesetl_useType=BASE
        , sesetl_validateLib=Y
         ) ;

%bldLibNm(sesetl_OMRSASLibraryObjName=&Solsystem_folder./&SdmLibObj./&SdmLibObj.,
          sesetl_useType=CON
          ) ;

/******************************************************************************************/
/* Convert the macro variable values for driver rate types, dimension types and           */
/* dimensions into datasets.                                                              */
/******************************************************************************************/

data WORK._DRATETYPES     (keep=PRATE_TYPE_MEMBER_ID RATE_TYPE_CD)
     WORK._CYCLEDIMTYPE   (keep=CODE VALUE)
     WORK._CYCLEDIM       (keep=CODE VALUE) ;
   length CODE $64 ;
   length NUMCODE 8 ;
   length VALUE $64 ;
   length TMPCODE $254 ;

   do nXX = 1 to 9999999999 ;
     CODE3 = strip( kscan("&fmsetl_drateTypeIds_SDM", nXX, "09"x) ) ;
     CODE4 = strip( kscan("&fmsetl_drateTypeCodes", nXX, "09"x) ) ;
     if CODE3 eq "" then leave ;
     PRATE_TYPE_MEMBER_ID = input(CODE3, 32.) ;
     RATE_TYPE_CD = CODE4 ;
     output WORK._DRATETYPES ;
   end ;

   do nXX = 1 to 9999999999 ;
     CODE = strip( kscan("&fmsetl_dimensionTypeCodes", nXX, "09"x) ) ;
     if CODE eq "" then leave ;
     NUMCODE = . ;
     VALUE = "OK" ;
     output WORK._CYCLEDIMTYPE ;
   end ;

   do nXX = 1 to 9999999999 ;
     CODE = strip( kscan("&fmsetl_dimensionCodes", nXX, "09"x) ) ;
     if CODE eq "" then leave ;
     NUMCODE = . ;
     VALUE = "OK" ;
     output WORK._CYCLEDIM ;
   end ;

run ;
%_chkError;
%if &_tmpRC %then %goto exit;

/******************************************************************************************/
/*                  Find the DDS RK for the DDS Driver Rate Set Code                      */
/******************************************************************************************/

proc sql noprint ;
    select distinct RATE_SET_RK into :_tmpDrateSetRK_DDS
        from _CONFORM.MISC_RATE_SET
        where RATE_SET_ID = "&fmsetl_drateSetCode_DDS";
quit ;
%_chkError;
%if &_tmpRC %then %goto exit;

/******************************************************************************************/
/* This code loads the dimension type codes from the work area data set and places them   */
/* into a concatenated list of dimension types that will later be used to concatenate the */
/* the members belonging to a driver rate.                                                */
/******************************************************************************************/
%macro mbrConcat ;
   %global fmsetl_concatMbrStmt ;
   %let fmsetl_concatMbrStmt= ;

   data _null_ ;
     length CONCATSTMT $32767 ;
     retain CONCATSTMT ;
     set WORK._CYCLEDIMTYPE end=nEnd ;
     if _n_ = 1 then do ;
       CONCATSTMT = strip(CONCATSTMT) ||
                    "strip(put(" || quote(strip(CODE)) || "n, 32.))"  ;
     end ;
     else do ;
       CONCATSTMT = strip(CONCATSTMT) || " || ',' || " ||
                    "strip(put(" || quote(strip(CODE)) || "n, 32.))"  ;
     end ;
     if nEnd then do ;
       call symput("fmsetl_concatMbrStmt", CONCATSTMT) ;
     end ;
   run ;

%mend ;

%mbrConcat ;

/******************************************************************************************/
/* This portion of code will take the _CONFORM.MISC_RATE table and extract the rates       */
/* based on dimension type values.  Also, all of the member rks for the members will be   */
/* converted to codes.  No _CONFORM to SDM conversion will be performed at this time.      */
/******************************************************************************************/

/* Extract the dimension types from dimension type work area data set and place them into */
/* a delimited list: ACCOUNT|INTORG|PRODUCT,... */

%macro dtypeConcat ;
   %global fmsetl_concatDtypeStmt ;
   %let fmsetl_concatDtypeStmt= ;

   %global fmsetl_dTypeCheck ;
   %let fmsetl_dTypeCheck= ;

   data _null_ ;
     length CONCATSTMT $32767 ;
     length CONCATDTYPE $32767 ;
     retain CONCATSTMT ;
     retain CONCATDTYPE ;

     set WORK._CYCLEDIMTYPE end=nEnd ;
     if _n_ = 1 then do ;
       CONCATSTMT = strip(CODE);
       CONCATDTYPE = quote(strip(CODE)) ;
     end ;
     else do ;
       CONCATSTMT = strip(CONCATSTMT) || "|" || strip(CODE) ;
       CONCATDTYPE = strip(CONCATDTYPE) || "," || quote(strip(CODE)) ;
     end ;
     if nEnd then do ;
       call symput("fmsetl_concatDtypeStmt", CONCATSTMT) ;
       call symput("fmsetl_dTypeCheck", CONCATDTYPE) ;
     end ;
   run ;

%mend dtypeConcat;

%dtypeConcat ;

/******************************************************************************************/
/* Create RK ==> Code formats for all of the dimension types in fmsetl_concatDtypeStmt.   */
/******************************************************************************************/
proc sql noprint;
   select count(*) INTO :_dtype_cnt
   from WORK._CYCLEDIMTYPE
   ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit ;

%macro fmtdtype/parmbuff;

%let _tmpDSN=_CONFORM.DIMENSION_TYPE;
%let fmt=fmt_dds_dtype;
%let x=_x;
%let dtypeString=%sysfunc(ksubstr(&syspbuff, 2), %eval(%sysfunc(klength(&syspbuff)) -2 ));

data work.fmt_dtype_fmtname;
   length FMTNAME $32;
   length TYPE $1;
   length START $32;
   length LABEL $32;
   stop;
run;

%do i = 1 %to &_dtype_cnt;
   %let dimtype=%sysfunc(kscan(%bquote(&dtypeString),&i,|));
   %let _tmpWhere = where=(DIMENSION_TYPE_CD = "&dimtype" and
                           VALID_FROM_DTTM <= &fmsetl_processedDTTM_To and
                           VALID_TO_DTTM >= &fmsetl_processedDTTM_To);
   data _null_;
      set _CONFORM.DIMENSION_TYPE(&_tmpWhere);
      call symput('prefix', %unquote(strip(TABLE_NM)));
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdtype_exit;

   %if (&dimtype eq ACCOUNT) or (&dimtype eq ANALYSIS) or (&dimtype eq COSTCTR) or
       (&dimtype eq CURRENCY) or (&dimtype eq EXTORG) or (&dimtype eq INTORG) or
       (&dimtype eq ITEMCAT) or (&dimtype eq PROFITCTR) or (&dimtype eq TIME) %then %do;
      %let dtypeid=&prefix._ID;
      %let dtypeRK=&prefix._RK;
      %if (&dimtype eq CURRENCY) %then
          %let dtypeid=CURRENCY_CD;
      %if (&dimtype eq ITEMCAT) %then
        %let dtypeid=ITEM_CATEGORY_CD;
   %end;
   %else %do;
      %let dtypeid=MEMBER_ID;
      %let dtypeRK=MEMBER_RK;
   %end;

   %let _tmpWhere = where=(VALID_FROM_DTTM <= &fmsetl_processedDTTM_To and
                           VALID_TO_DTTM >= &fmsetl_processedDTTM_To);
   %let _tmpFormat=&fmt&i&x;

   data work._tmp_dtype_fmtname;
      length FMTNAME $32;
      length TYPE $1;
      length START $32;
      length LABEL $32;
      FMTNAME="FMT_DTYPE_FMTNAME";
      TYPE="C";
      START="&dimtype";
      LABEL="&_tmpFormat";
      output;
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdtype_exit;

   proc append base=work.fmt_dtype_fmtname data=work._tmp_dtype_fmtname;
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdtype_exit;

   %if &dimtype eq CURRENCY or &dimtype eq ITEMCAT %then %do;
      data work.&_tmpFormat;
         length START $32;
         length LABEL $32;
         retain FMTNAME "&_tmpFormat";
         retain TYPE "C";
         retain HLO "";
         START = '~~';
         LABEL = '';
         output;
         HLO = 'O';
         LABEL = '*** ERROR ***';
         output;
         keep START LABEL FMTNAME TYPE HLO;
      run;
      %_chkError;
      %if &_tmpRC %then %goto fmtdtype_exit;
   %end;
   %else %do;
      data work.&_tmpFormat;
         length START 8;
         length LABEL $32;
         retain FMTNAME "&_tmpFormat";
         retain TYPE "N";
         retain HLO "";
         set _CONFORM.&prefix(&_tmpWhere) end=last;
         START = &dtypeRK;
         LABEL = &dtypeid;
         output;
         if (last) then do;
            START = .;
            LABEL = '';
            output;
            HLO = 'O';
            START = .;
            LABEL = '*** ERROR ***';
            output;
         end;
         keep START LABEL FMTNAME TYPE HLO;
      run;
      %_chkError;
      %if &_tmpRC %then %goto fmtdtype_exit;
   %end;

   proc format cntlin=&_tmpFormat library=WORK;
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdtype_exit;

   %let format_missing = 0;
   %if &dimtype eq CURRENCY or &dimtype eq ITEMCAT %then %do;
     %if not %sysfunc( cexist(work.formats.&_tmpFormat..formatc) ) %then %do;
        %let format_missing = 1;
     %end;
   %end;
   %else %do;
     %if not %sysfunc( cexist(work.formats.&_tmpFormat..format) ) %then %do;
        %let format_missing = 1;
     %end;
   %end;
   %if &format_missing = 1 %then %do;;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
               msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
      %goto fmtdtype_exit;
   %end;
%end;

proc format cntlin=fmt_dtype_fmtname library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto fmtdtype_exit;

%let format_missing = 0;

%if not %sysfunc( cexist(work.formats.fmt_dtype_fmtname.formatc) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<FMT_DTYPE_FMTNAME>, msgTxt2=&syserr, msgPutlog=&putlog);
   %let format_missing = 1;
   %goto fmtdtype_exit;
%end;

%fmtdtype_exit:

%mend fmtdtype;

%fmtdtype(&fmsetl_concatDtypeStmt);

%if &_tmpRC or &format_missing %then
    %goto exit;

/**********************************************************************************************/
/* FMT_COL_TO_DTYPE: Derives the dimension type from the column name in the MISC_RATE table   */
/**********************************************************************************************/

%let _tmpDSN=_CONFORM.DIMENSION_TYPE;
%let _tmpFormat=FMT_COL_TO_DTYPE;
%let _tmpStart=MISC_COLUMN_NM;
%let _tmpLabel=DIMENSION_TYPE_CD;

data WORK.&_tmpFormat;
   length START $ 50;
   length LABEL $ 32;
   retain FMTNAME "&_tmpFormat";
   retain TYPE "C";
   retain HLO "";
   set &_tmpDSN;
   START = &_tmpStart;
   LABEL = &_tmpLabel;
   keep START LABEL FMTNAME TYPE HLO;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sort data=&_tmpFormat nodupkeys;
  by start;
run;
proc format cntlin=&_tmpFormat library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%if not %sysfunc( cexist(work.formats.&_tmpFormat..formatc) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
   %goto exit;
%end;

/******************************************************************************************/
/* Create rateCols macro that contains list of all columns existing in the MISC_RATE      */
/* table of the dds.                                                                      */
/******************************************************************************************/

proc sql noprint;
  create table work.drate_cols as
  select name
  from dictionary.columns
  where upcase(libname) = "_CONFORM" and upcase(memname) = "MISC_RATE"
  ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sql noprint;
   select count(*) INTO :_col_cnt
   from work.drate_cols
   ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit;

%macro drateCols ;

   data _null_ ;
     set work.drate_cols end=nEnd ;
     if _n_ = 1 then
       call symput("rateCols", name);
     else
       call symput("rateCols", strip(symget("rateCols")) || "," || name);
   run ;

%mend drateCols;

%drateCols;

/******************************************************************************************/
/* Filter out the rates based on rate set and dimensions.                                 */
/******************************************************************************************/

%let _tmpDSN = _CONFORM.MISC_RATE;
%if not %sysfunc( exist(&_tmpDSN) ) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=14
          ,  msgPutlog=N);
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=5
          , msgTxt1=&_tmpDSN, msgTxt2=&sesgmsg_msgReturn
          , msgPutlog=&putlog);
   %goto exit;
%end ;

%macro filterRates/parmbuff;

%global if_statement ;
%let if_statement= ;

%let _tmpDSN = _CONFORM.MISC_RATE;
%let _tmpWhere = where=(RATE_SET_RK = &_tmpDrateSetRK_DDS and
                        PROCESSED_DTTM > &fmsetl_processedDTTM_From and
                        PROCESSED_DTTM <= &fmsetl_processedDTTM_To);
%let cd=_CD;

data work._tmpdrate ;
   length no_output 8;
   set &_tmpDSN(&_tmpWhere);
   no_output = 0;
   %let colString=%sysfunc(ksubstr(&syspbuff, 2), %eval(%sysfunc(klength(&syspbuff)) -2 ));
   %do i = 1 %to &_col_cnt;
      %let colName=%sysfunc(kscan(%bquote(&colString),&i));
      %if &colName ne RATE_SET_RK and &colName ne RATE_TYPE_CD and
                &colName ne RATE_SOURCE_CD and &colName ne RATE_VALUE and
                &colName ne EFFECTIVE_FROM_DT and &colName ne EFFECTIVE_TO_DT and
                &colName ne PROCESSED_DTTM %then %do;
         %let dimtype=%sysfunc(putc(&colName, FMT_COL_TO_DTYPE.));
         %let _tmp_fmtname=%sysfunc(putc(&dimtype, FMT_DTYPE_FMTNAME.));
         %let dimtypecd=%sysfunc(strip(&dimtype))&cd;
         format &dimtypecd $char32.;

         %do n = 1 %to &_dtype_cnt;
             %let dtype_temp=%sysfunc(kscan(%bquote(&fmsetl_dTypeCheck),&n));
             %if &n = 1 %then
               %let if_statement = "&dimtype" = &dtype_temp ;
             %else
               %let if_statement = &if_statement or "&dimtype" = &dtype_temp;
         %end;

         %if &if_statement %then %do;
            if "&dimtype" in ("CURRENCY", "ITEMCAT") then do;
               &dimtypecd = &colName;
            end;
            else do;
               &dimtypecd = put(&colName., &_tmp_fmtname..);
            end;
         %end;
         %else %do;
            if "&dimtype" in ("CURRENCY", "ITEMCAT") then do;
               if &colName ne "" then do;
                  no_output = 1;
               end;
            end;
            else if &colName ne . then do;
               no_output = 1;
            end;
            else do;
               &dimtypecd = "";
            end;
         %end;
         keep &dimtypecd ;
      %end;
   %end;
   keep RATE_SET_RK RATE_TYPE_CD RATE_SOURCE_CD RATE_VALUE EFFECTIVE_FROM_DT
        EFFECTIVE_TO_DT PROCESSED_DTTM;
   if no_output = 0 then
      output;
run;
%_chkError;

%mend filterRates;

%filterRates(&rateCols);

%_chkError;
%if &_tmpRC %then %goto exit;

/******************************************************************************************/
/* From this point on, the intermediate rate table created from the rate table in the dds */
/* will now be validated against the sassdm and dds values will be converted to sassdm    */
/* values.                                                                                */
/******************************************************************************************/

/* Check if _SDMLIB.SAS_DIM_TYPE exists */
%let _tmpDSN = _SDMLIB.SAS_DIM_TYPE;
%if not %sysfunc( exist(&_tmpDSN) ) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=10
           , msgPutlog=N);
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3
           , msgTxt1=sas_dim_type, msgTxt2=&sesgmsg_msgReturn
           , msgPutlog=&putlog);
   %goto exit ;
%end;

/* Check if _SDMLIB.SAS_DIMENSION exists */
%let _tmpDSN = _SDMLIB.SAS_DIMENSION;
%if not %sysfunc( exist(&_tmpDSN) ) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=11
           , msgPutlog=N);
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3
           , msgTxt1=sas_dimension, msgTxt2=&sesgmsg_msgReturn
           , msgPutlog=&putlog);
   %goto exit ;
%end;

/* Check for the existence of active records in the dimension table */
proc sql noprint;
   select count(*) INTO :_rec_cnt
   from &_tmpDSN
   ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit ;

%if (&_rec_cnt < 1) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=11
           , msgPutlog=N);
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=4
           , msgTxt1=dimension, msgTxt2=&sesgmsg_msgReturn
           , msgPutlog=&putlog);
   %goto exit ;
%end;

/* Check if driver rate's dimension table exists */
%let _tmpDSN = WORK._CYCLEDIM;
%if not %sysfunc( exist(&_tmpDSN) ) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=12
           , msgPutlog=N);
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=5
          , msgTxt1=&_tmpDSN, msgTxt2=&sesgmsg_msgReturn
          , msgPutlog=&putlog);
   %goto exit;
%end;

proc sort data=&_tmpDSN;
   by CODE;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

/* Check if _SDMLIB.SAS_MEMBER exists */
%let _tmpDSN = _SDMLIB.SAS_MEMBER;
%if not %sysfunc( exist(&_tmpDSN) ) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=13
           , msgPutlog=N);
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=3
           , msgTxt1=sas_member, msgTxt2=&sesgmsg_msgReturn
           , msgPutlog=&putlog);
   %goto exit ;
%end ;

/* Check for the existence of active records in the member table */
proc sql noprint;
   select count(*) INTO :_rec_cnt
   from &_tmpDSN
   ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit ;

%if (&_rec_cnt < 1) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=13
           , msgPutlog=N);
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=4
           , msgTxt1=dimension, msgTxt2=&sesgmsg_msgReturn
           , msgPutlog=&putlog);
   %goto exit ;
%end;

/******************************************************************************************/
/* build lists of the driver rate dimension types in macro vars                           */
/*                                                                                        */
/* Name: drdtypes & dtype_ids                                                             */
/* Contents: list of dimension types codes and ids                                        */
/*                                                                                        */
/* Name: dimcnt                                                                           */
/* Contents: number of items in above lists                                               */
/******************************************************************************************/

%let _tmpSortVar = DIMENSION_CD;
data WORK._TMPALLDIMS;
   set WORK._CYCLEDIM;
   &_tmpSortVar = CODE;
   keep &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sort data = WORK._TMPALLDIMS;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%let _tmpWhere = where=(VALID_FROM_DTTM <= &fmsetl_processedDTTM_To and
                        VALID_TO_DTTM >= &fmsetl_processedDTTM_To);

data WORK._TMPSDMDIM;
   set _SDMLIB.SAS_DIMENSION(&_tmpWhere);
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sort data = WORK._TMPSDMDIM;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

data WORK._TMPALLDIMS
     WORK._TMPMISSINGDIMS;
   merge WORK._TMPALLDIMS (in = inA)
         WORK._TMPSDMDIM (in = inB);
      by &_tmpSortVar;
   keep DIMENSION_CD INTERNAL_DIMENSION_ID DIM_TYPE_ID;
   if (inA and ^inB) then
      output WORK._TMPMISSINGDIMS;
   else if (inA) then
      output WORK._TMPALLDIMS;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sql noprint;
   select count(*) INTO :missingCnt FROM WORK._TMPMISSINGDIMS;
quit;
%_chkError;
%if &_tmpRC %then %goto exit;

%if (&missingCnt > 0) %then %do;
   data _null_;
      set WORK._TMPMISSINGDIMS (obs=1);
      call symput("missing_dim", strip(DIMENSION_CD));
   run;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=6
           , msgTxt1=<&missing_dim>, msgPutlog=&putlog);
   %goto exit ;
%end;

%let _tmpSortVar = DIM_TYPE_ID;
proc sort data = WORK._TMPALLDIMS;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%let _tmpWhere = where=(VALID_FROM_DTTM <= &fmsetl_processedDTTM_To and
                        VALID_TO_DTTM >= &fmsetl_processedDTTM_To);

data WORK._TMPSDMDIMTYPE;
   set _SDMLIB.SAS_DIM_TYPE (&_tmpWhere);
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sort data = WORK._TMPSDMDIMTYPE;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

data WORK._TMPALLDIMS;
   merge WORK._TMPALLDIMS (in = inA)
         WORK._TMPSDMDIMTYPE;
      by &_tmpSortVar;
   keep DIMENSION_CD INTERNAL_DIMENSION_ID DIM_TYPE_ID DIM_TYPE_CD;
   if (inA) then
      output;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sql noprint;
   select count(*) INTO :dimcnt FROM WORK._TMPALLDIMS;
quit;
%_chkError;
%if &_tmpRC %then %goto exit;

data _null_;
   set WORK._TMPALLDIMS;
   if (_n_ = 1) then do;
      call symput("drdtypes",DIM_TYPE_CD);
      call symput("dtype_ids",DIM_TYPE_ID);
   end;
   else do;
      call symput("drdtypes",strip(symget("drdtypes"))||"|"||DIM_TYPE_CD);
      call symput("dtype_ids",strip(symget("dtype_ids"))||","||DIM_TYPE_ID);
   end;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

/******************************************************************************************/
/* Create needed formats                                                                  */
/******************************************************************************************/

/* FMT_TO_DIM */
%let _tmpDSN=WORK._TMPALLDIMS;
%let _tmpFormat=FMT_TO_DIM;
%let _tmpStart=DIM_TYPE_CD;
%let _tmpLabel=DIMENSION_CD;

data WORK.&_tmpFormat;
   length START $ 64;
   length LABEL $ 32;
   retain FMTNAME "&_tmpFormat";
   retain TYPE "C";
   retain HLO "";
   set &_tmpDSN;
   START = &_tmpStart;
   LABEL = &_tmpLabel;
   keep START LABEL FMTNAME TYPE HLO;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc format cntlin=&_tmpFormat library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%if not %sysfunc( cexist(work.formats.&_tmpFormat..formatc) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
   %goto exit;
%end;

/* FMT_DIMS */
%let _tmpDSN=WORK._TMPALLDIMS;
%let _tmpFormat=FMT_DIMS;
%let _tmpStart=DIM_TYPE_ID;
%let _tmpLabel=INTERNAL_DIMENSION_ID;
data work.&_tmpFormat;
   length START 8;
   length LABEL 8;
   retain FMTNAME "&_tmpFormat";
   retain TYPE "I";
   retain HLO "";
   set &_tmpDSN;
   START = &_tmpStart;
   LABEL = &_tmpLabel;
   keep START LABEL FMTNAME TYPE HLO;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc format cntlin=&_tmpFormat library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%if not %sysfunc( cexist(work.formats.&_tmpFormat..infmt) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
   %goto exit;
%end;

/* FMT_DTYPE_RK */
%let _tmpDSN=WORK._TMPALLDIMS;
%let _tmpFormat=FMT_DTYPE_RK;
%let _tmpStart=DIMENSION_CD;
%let _tmpLabel=DIM_TYPE_ID;
data work.&_tmpFormat;
   length START $ 64;
   length LABEL 8;
   retain FMTNAME "&_tmpFormat";
   retain TYPE "I";
   retain HLO "";
   set &_tmpDSN;
   START = &_tmpStart;
   LABEL = &_tmpLabel;
   keep START LABEL FMTNAME TYPE HLO;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc format cntlin=&_tmpFormat library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%if not %sysfunc( cexist(work.formats.&_tmpFormat..infmt) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
   %goto exit;
%end;

/* FMT_MEMTYPE -- format to be used for data validation */
%let _tmpFormat=FMT_MEMTYPE;
%let _tmpStart=MEMBER_ID;
%let _tmpLabel=DIM_TYPE_CD;
%let _tmpWhere=where=(VALID_FROM_DTTM <= &fmsetl_processedDTTM_To and
                      VALID_TO_DTTM >= &fmsetl_processedDTTM_To);

%let _tmpDSN=WORK._TMPALLDIMS;
%let _tmpSortVar=INTERNAL_DIMENSION_ID;
proc sort data = &_tmpDSN nodupkey;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%let _tmpDSN=_SDMLIB.SAS_MEMBER;

data WORK._TMPMEMBER;
   set &_tmpDSN(&_tmpWhere);
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc sort data = WORK._TMPMEMBER;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

data work.&_tmpFormat;
   length START 8;
   length LABEL $ 32;
   retain FMTNAME "&_tmpFormat";
   retain HLO "";
   retain TYPE "N";
   merge WORK._TMPALLDIMS (in=inA)
         WORK._TMPMEMBER (in=inB);
      by &_tmpSortVar;
   START = &_tmpStart;
   LABEL = &_tmpLabel;
   keep START LABEL FMTNAME TYPE HLO;
   if (inA and inB) and (DIM_TYPE_CD ^= 'TRADER') then
      output;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

data WORK.&_tmpFormat;
   set WORK.&_tmpFormat end=last;
   output;
   if (last) then do;
      HLO = 'O';
      START = .;
      LABEL = '*** ERROR ***';
      FMTNAME = "&_tmpFormat";
      TYPE = "N";
      output;
   end;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc format cntlin=&_tmpFormat library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%if not %sysfunc( cexist(work.formats.&_tmpFormat..format) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
   %goto exit;
%end;

/* Create the formats for all of the dimensions */

%macro fmtdims/parmbuff;

%let _tmpDSN=_SDMLIB.SAS_MEMBER;
%let _tmpStart=MEMBER_CD;
%let _tmpLabel=MEMBER_ID;

%let fmt=fmt_dtype;
%let x=_x;

%do i = 1 %to &dimcnt;
   %let dtype_rk=%sysfunc(kscan(&syspbuff,&i,'(,)'));
   %let _tmpWhere=where=(INTERNAL_DIMENSION_ID = input(symget("dtype_rk"), FMT_DIMS.) and
                         VALID_FROM_DTTM <= &fmsetl_processedDTTM_To and
                         VALID_TO_DTTM >= &fmsetl_processedDTTM_To);
   proc sort data = &_tmpDSN(&_tmpWhere
                    keep= &_tmpStart &_tmpLabel INTERNAL_DIMENSION_ID VALID_FROM_DTTM VALID_TO_DTTM)
              out = work._tmpSort(drop= INTERNAL_DIMENSION_ID VALID_FROM_DTTM VALID_TO_DTTM);
      by &_tmpStart;
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdims_exit;

   %let _tmpFormat=&fmt&dtype_rk&x;

   data work.&_tmpFormat;
      length START $ 64;
      length LABEL 8;
      retain FMTNAME "&_tmpFormat";
      retain TYPE "I";
      retain HLO "";
      set WORK._TMPSORT end=last;
      START = strip(&_tmpStart);
      LABEL = &_tmpLabel;
      output;
      if (last) then do;
         START = '';
         LABEL = .;
         output;
         HLO = 'O';
         START = .;
         LABEL = .;
         output;
      end;
      keep START LABEL FMTNAME TYPE HLO;
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdims_exit;

   proc format cntlin=&_tmpFormat library=WORK;
   run;
   %_chkError;
   %if &_tmpRC %then %goto fmtdims_exit;

   %let format_missing = 0;
   %if not %sysfunc( cexist(work.formats.&_tmpFormat..infmt) ) %then %do;
      %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
               msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
      %let format_missing = 1;
      %goto fmtdims_exit;
   %end;

%end;

%fmtdims_exit:

%mend fmtdims;

%fmtdims(&dtype_ids);

%if &_tmpRC or &format_missing %then
    %goto exit;

/* Create format FMT_DRATE_TYPE */

%let _tmpDSN = _SDMLIB.SAS_DIM_TYPE;
%let drate_type_int_id = 0;
proc sql noprint;
  select INTERNAL_DIM_TYPE_ID into :drate_type_int_id from &_tmpDSN
  where DIM_TYPE_CD = 'RATE_TYPE' and VALID_TO_DTTM  >= &fmsetl_processedDTTM_To;
quit;
%_chkError;
%if &_tmpRC %then %goto exit;

%if &drate_type_int_id = 0 %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=8,
            msgTxt1=<RATE_TYPE>, msgPutlog=&putlog);
   %goto exit;
%end ;

%let _tmpDSN = _SDMLIB.SAS_MEMBER;
%let _tmpFormat=FMT_DRATE_TYPE;
%let _tmpStart=MEMBER_CD;
%let _tmpLabel=MEMBER_ID;
%let _tmpWhere=where=(INTERNAL_DIM_TYPE_ID = &drate_type_int_id and
                      VALID_TO_DTTM >= &fmsetl_processedDTTM_To);

data work.&_tmpFormat;
   length START $ 64;
   length LABEL 8;
   retain FMTNAME "&_tmpFormat";
   retain TYPE "I";
   retain HLO "";
   set &_tmpDSN(&_tmpWhere);
   START = strip(&_tmpStart);
   LABEL = &_tmpLabel;
   keep START LABEL FMTNAME TYPE HLO;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

/* Check for the existence of active rate_type records in the member table */
proc sql noprint;
   select count(*) INTO :_rec_cnt
   from WORK.&_tmpFormat
   ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit ;

%if (&_rec_cnt < 1) %then %do;
  %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=9,
            msgTxt1=<RATE_TYPE>, msgPutlog=&putlog);
  %goto exit ;
%end;

proc sort data = WORK.&_tmpFormat NODUPKEY;
   by START;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

proc format cntlin=&_tmpFormat library=WORK;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%if not %sysfunc( cexist(work.formats.&_tmpFormat..infmt) ) %then %do;
   %sesgmsg(msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=7,
            msgTxt1=<&_tmpFormat>, msgTxt2=&syserr, msgPutlog=&putlog);
   %goto exit;
%end;

/******************************************************************************************/
/* Convert dds member codes to sassdm member rks and concatenate these members together.  */
/* Also, validate the members based on dimension type.                                    */
/******************************************************************************************/

%macro ratework/parmbuff;

%let err=_ERROR;
%let fmt=fmt_dtype;
%let x=_x.;
%let cd=_CD;
%let code=_CODE;

%let _tmpDSN = WORK._TMPDRATE;

data WORK._TMPDRATE (keep=PRATE_TYPE_MEMBER_ID CONCAT_MEMBER_IDS PRATE)
     WORK.BADRECS /*(keep=PRATE_TYPE_MEMBER_ID CONCAT_MEMBER_IDS PRATE)*/
     ;
   length PRATE_TYPE_MEMBER_ID 8;
   length PRATE 8;
   format PRATE best32.;
   length BAD_RECORD 8;
   length MEM_DIMTYPE $ 8;
   length DIMTYPE_HOLD $ 8;
   length CONCAT_MEMBER_IDS $ 255;
   length no_output 8;
   set &_tmpDSN;
   PRATE_TYPE_MEMBER_ID = input(RATE_TYPE_CD, FMT_DRATE_TYPE.) ;
   PRATE = RATE_VALUE ;
   BAD_RECORD = 0;
   /* Validate the members of the dimension types existing in the driver rate table */
   %let dtypeString=%sysfunc(ksubstr(&syspbuff, 2), %eval(%sysfunc(klength(&syspbuff)) -2 ));
   no_output = 0;
   %do i = 1 %to &dimcnt;
       %let dimtype=%sysfunc(kscan(%bquote(&dtypeString),&i,|));
       %let dimname=%sysfunc(putc(&dimtype, $FMT_TO_DIM.));
       %let dimtype_rk=%sysfunc(inputn(&dimname, FMT_DTYPE_RK.));
       /* %let dimtype1=%sysfunc(putc(%sysfunc(upcase(%sysfunc(strip(&dimtype)))), $DTPCOL.)); */
       %let dimtypecd=%sysfunc(strip(&dimtype))&cd;
       %let dimtypecode=%sysfunc(strip(&dimtype))&code;
       %let dimtypeerr=%sysfunc(strip(&dimtype))&err;
       DIMTYPE_HOLD = "&dimtype";
       "&dimtype"n=input(strip("&dimtypecd"n), &fmt&dimtype_rk.&x);
       checkId = "&dimtype"n ;
       if (checkID eq .) then
         "&dimtype"n = 0 ;
       MEM_DIMTYPE = strip(put(checkId, FMT_MEMTYPE.));
       if checkID ne . then do;
          if (DIMTYPE_HOLD = 'TRADER') then do;
             if (MEM_DIMTYPE = 'INTORG') then do;
                "&dimtypeerr"n = 0;
             end;
             else do;
                bad_record = 1;
                "&dimtypeerr"n = 1;
             end;
          end;
          else do;
             if (MEM_DIMTYPE = DIMTYPE_HOLD) then do;
                "&dimtypeerr"n = 0;
             end;
             else do;
                BAD_RECORD = 1;
                "&dimtypeerr"n = 1;
             end;
          end;
       end;
       else if &dimtypecd ne '' then
          no_output = 1;
       "&dimtypecode"n = "&dimtypecd"n;
   %end;

   if not no_output then do;
      if (BAD_RECORD = 1) then do;
/*         keep PRATE_TYPE_MEMBER_ID CONCAT_MEMBER_IDS PRATE */
              %do i = 1 %to &dimcnt;
                  %let dimtype=%sysfunc(kscan(%bquote(&dtypeString),&i,|));
                  /* %let dimtype1=%sysfunc(putc(%sysfunc(upcase(%sysfunc(strip(&dimtype)))), $DTPCOL.)); */
                  %let dimtypecode=%sysfunc(strip(&dimtype))&code;
                  %let dimtypeerr=%sysfunc(strip(&dimtype))&err;
/*                  "&dimtype"n "&dimtypecode"n "&dimtypeerr"n */
              %end;
              ;
         output WORK.BADRECS;
      end;
      else do;
/*         keep PRATE_TYPE_MEMBER_ID PRATE */
              %do i = 1 %to &dimcnt;
                  %let dimtype=%sysfunc(kscan(%bquote(&dtypeString),&i,|));
                  /* %let dimtype1=%sysfunc(putc(%sysfunc(upcase(%sysfunc(strip(&dimtype)))), $DTPCOL.)); */
                  %let dimtypecode=%sysfunc(strip(&dimtype))&code;
/*                  "&dimtype"n "&dimtypecode"n */
              %end;
              ;

         CONCAT_MEMBER_IDS = &fmsetl_concatMbrStmt ;
         output WORK._TMPDRATE;
      end;
   end;
run;
%_chkError;
%if &_tmpRC %then %goto ratework_exit;

/******************************************************************************************/
/* Filter rates down by type.                                                             */
/******************************************************************************************/

%let _tmpSortVar = PRATE_TYPE_MEMBER_ID;
proc sort data=WORK._TMPDRATE;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto ratework_exit;

/* Check if cycle's driver rate type table exists */
%let _tmpDSN = WORK._DRATETYPES;
%if not %sysfunc( exist(&_tmpDSN) ) %then %do;
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=17
           , msgPutlog=N);
   %sesgmsg( msgDsn=SASHELP.SFMMSGS, msgEntry=&entry, msgCode=10
           , msgTxt1=&_tmpDSN, msgTxt2=&sesgmsg_msgReturn
           , msgPutlog=&putlog);
   %goto ratework_exit;
%end;

proc sort data=&_tmpDSN;
   by &_tmpSortVar;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

data WORK.ETL_DRATE;
   merge WORK._TMPDRATE (in = inA)
         &_tmpDSN (in = inB);
      by &_tmpSortVar;
   if (inA) and (inB) then
      output;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

/* THERE SHOULD NEVER BE MORE THAN 1 RECORD FOR A DRIVER RATE BASED ON TYPE AND MEMBERS  */
/* IN THE DDS, THUS MAKING THE FOLLOWING CODE UNNECESSARY.  JUST COMMENTING OUT FOR NOW, */
/* IN CASE WE DISCOVER WE DO NEED IT.                                                    */

/*
proc sort data=WORK._TMPDRATE;
   BY DESCENDING PROCESSED_DTTM;
%_chkError;
%if &_tmpRC %then %goto ratework_exit;

proc sort data=WORK._TMPDRATE nodupkey;
   by DRATE_TYPE_ID CONCAT_MEMBER_IDS;
run;
%_chkError;
%if &_tmpRC %then %goto ratework_exit;

data WORK.ETL_DRATE;
   set WORK._TMPDRATE;
   drop PROCESSED_DTTM;
run;
%_chkError;
%if &_tmpRC %then %goto ratework_exit;
*/

%ratework_exit:

%mend ratework;

%ratework(&drdtypes);

%if &_tmpRC %then %goto exit;

/******************************************************************************************/

proc sql noprint;
   connect to &sesetl_EngineType ( &sesetl_BestLogin &sesetl_ConnectionOptions );
   execute(create table &fmsetl_tempCreateTableNm (
           PRATE_IDX INT(11),
           PRATE_TYPE_MEMBER_ID int(11) NOT NULL default 0,
           CONCAT_MEMBER_IDS varchar(255) NOT NULL default '',
           PRATE double NOT NULL default 0
           )ENGINE=myISAM
           ) by &sesetl_EngineType ;
   disconnect from &sesetl_EngineType ;
quit;
%_chkError;
%if &_tmpRC %then %goto exit;

data WORK._TMPRATECONCAT(keep=PRATE_IDX PRATE_TYPE_MEMBER_ID CONCAT_MEMBER_IDS PRATE
                         drop=IDXCNT) ;
  length PRATE_IDX 8 ;
  length PRATE_TYPE_MEMBER_ID 8 ;
  length CONCAT_MEMBER_IDS $255 ;
  length PRATE 8 ;
  format PRATE best32.;
  retain IDXCNT 0 ;
  set WORK.ETL_DRATE;
  IDXCNT = IDXCNT + 1 ;
  PRATE_IDX = IDXCNT ;
run ;
%_chkError;
%if &_tmpRC %then %goto exit;

%sesFMS_uploadDataToSDM(cSrcNm=WORK._TMPRATECONCAT, cTrgNm=&fmsetl_tempCreateTableNm);

proc sort in=WORK.ETL_DRATE out=WORK._countRates1 ;
  by PRATE_TYPE_MEMBER_ID ;
run ;
%_chkError;
%if &_tmpRC %then %goto exit;

proc summary data=WORK._countRates1 ;
  by PRATE_TYPE_MEMBER_ID ;
  output out=WORK._countRates1 (drop=_TYPE_
                   rename=(_FREQ_=RATE_CNT));
run ;
%_chkError;
%if &_tmpRC %then %goto exit;

data _SDMLIB.&fmsetl_tempStatusTableNm ;
  set WORK._countRates1;
run ;
%_chkError;
%if &_tmpRC %then %goto exit;

data null ;
   call symput('nElapsedTime', datetime() - symget('nStartTime')) ;
run;
%_chkError;
%if &_tmpRC %then %goto exit;

%put TIMER: Total time to import Driver Rates: &nElapsedTime ;

%let fmsetl_statusId = 0; /* Program ran successful */

%exit:

%if &fmsetl_statusID ne 0 %then %do;
   %let fmsetl_error = &sesgmsg_msgCodeReturn;
   %let fmsetl_errormsg = &sesgmsg_msgReturn;
%end;

%mend cycdrate ;
